/* SIMULATE A 16-BIT 4-FUNCTION ALU */
/*
tcc -c -mm tutor1

tutor2.obj must be linked into main program tutor1,  for example:
  tlink -x \tc\lib\c0m tutor2 tutor1,tutor1,,\tc\lib\cm
*/

/* --------------------------- Required Headers ----------------------------- */
#include "tutor1.h" /* Includes stdio.h and tutor3.h */

/* ---------------------------------- main ---------------------------------- */
void main(void)

{ /* BEGIN main */
short i;              /* General index */
short bit;            /* Bit number */
short abits;          /* Bit count "a" */
short bbits;          /* Bit count "b" */
short nrbits;         /* Number of bits */
char  ci;             /* Carry-in */
char  co;             /* Carry-out */
char  cis;            /* Carry into sign */
char  sign;           /* Sign */
char  oflo;           /* Oflo */
char  a[WORDSZ];      /* Operand "a" */
char  b[WORDSZ];      /* Operand "b" */
char  f[3];           /* Function (as entered by user) */
char  result[WORDSZ]; /* Result of operation */
char  func[4];        /* Function (as decoded by 2-to-4 decoder simulator) */

printf("\nA and B must be given as 16-bit binary values.\n"
  "(To quit, enter a CR alone at any prompt.)\n");
while(1){  /* Main loop (terminated only by break) */
  getfunc(f,&nrbits); /* get function code */
  if(nrbits==0)break;
  DECODE(f,func) /* Decode the function code */
  getops(func,a,b,&nrbits);
  if(nrbits==0)break;
  if(func[0]=='1')
    sum16(a,b,result,&sign,&oflo);
  if(func[1]=='1')
    and16(a,b,result);
  if(func[2]=='1')
    pass16(a,result);
  if(func[3]=='1')
    not16(a,result);
  showres(func,result,sign,oflo);
  } /* END main loop */
} /* END main */

/* -------------------------------- showres --------------------------------- */
void showres(char func[],char result[],char sign,char oflo)
/* Show a 16-bit result on the vdu.                                           */
/*   func:      Array holding decoded function                                */
/*   result:    Result array                                                  */
/*   sign,oflo: Part of add16 results                                         */

{ /* BEGIN showres */
short bit; /* bit index */

printf("R=");
for(bit=0;bit<16;bit++)
  printf("%c",result[bit]);
if(func[0]=='1')
  printf(" Sign=%c Oflo=%c",sign,oflo);
putchar('\n');
} /* END showres */

/* -------------------------------- getfunc --------------------------------- */
void getfunc(char f[],short *nrbits)
/* Get function code                                                          */
/*   f:      /* Function code word                                            */
/*   nrbits: /* Pointer to count of bits received                             */

{ /* BEGIN getfunc */
char valid=0; /* Boolean: 0=invalid; other=valid */

do{ /* Get a valid code */
  printf("\nFunction? (00=A+B; 01=A and B; 10=A; 11=not A;):");
  getwd(f,2,nrbits);  /* Get 2 char from keyboard into f */
  if(*nrbits==0)
    return; /* Only CR given */
  if(*nrbits!=2){ /* Check number of bits */
    printf("Need exactly 2 bits; got %d",*nrbits);
    continue; /* Immediately reiterate "Get valid code" loop */
    } /* END Check number of bits */
  if((f[0]!='0'&&f[0]!='1')||(f[1]!='0'&&f[1]!='1')){ /* Check code */
    printf("Only 00, 01, 10, and 11 are valid.");
    continue; /* Immediately reiterate "Get valid code" loop */
    } /* END Check code */
  valid=1; /* Indicate valid code received */
  }while(!valid); /* END Get a valid code */
} /* END getfunc */

/* --------------------------------- getops --------------------------------- */
void getops(char func[],char a[],char b[],short *nrbits)
/* Get the operand(s).                                                        */
/*   func:   /* Array containing function code                                */
/*   a,b:    /* Arrays for a-operand and b-operand                            */
/*   nrbits: /* Pointer to bit count                                          */

{ /* BEGIN getops */
                             /*-- Local Macro --*/
/* Check for nbits=16.							      */
#define CKCOUNT{\
          if(nbits!=16)\
            printf("Need exactly 16 bits; got %d\n",nbits);\
          }
short nbits=99;

while(nbits!=0&&nbits!=16){ /* Insist on 16 or 0 bits for A */
  printf("A?");
  *nrbits=0;
  getwd(a,16,&nbits); /* Get 16 char from keyboard into A */
  if(nbits==0)
    return;
  CKCOUNT
  } /* END Insist on 16 or 0 bits for A */ 
nbits=99;
if(func[0]=='1'||func[1]=='1') /* If B needed */
  while((nbits!=0)&&(nbits!=16)){ /* Insist on 16 or 0 bits for B */
    printf("B?");
    *nrbits=0;
    getwd(b,16,&nbits); /* Get 16 char from keyboard into B */
    if(nbits!=0)
      CKCOUNT
    } /* END Insist on 16 or 0 bits for B */
*nrbits=nbits;
} /* END getops */

/* --------------------------------- getwd ---------------------------------- */
void getwd(char a[],short limit,short *nchar)
/* Get up to limit chars from keyboard.                                       */
/*   a:     /* Array for receiving characters                                 */
/*   limit: /* Maximum number of characters (excluding '\0')                  */
/*   nchar: /* Pointer to number of characters received                       */

{ /* BEGIN getwd */
short i;  /* General index */
char  cc; /* Current char */
i=0;
a[limit]='\0'; /* Ensure string termination */
fflush(stdin);
do{ /* Get char from keyboard */
  cc=getchar();
  if(i<limit) /* Don't exceed array capacity */
    a[i]=(cc=='\n')?'\0':cc; /* Replace \n with string terminator */
  i++;
  if(cc==EOF)
    XCEPTN(printf("Aborted: Error reading from keyboard.");
           exit(1));
    /* getchar() returned EOF. */
  }while(cc!='\n'); /* END Get char from keyboard */
*nchar=i-1; /* Don't count '\0' */
} /* END getwd */
/*============================================================================*/

0007471D
