/* SUPPORT FUNCTIONS FOR SIMULATING A 16-BIT 4-FUNCTION ALU */
/*
tcc -c -mm tutor2

tutor2.obj must be linked into main program tutor1,  for example:
  tlink -x \tc\lib\c0m tutor2 tutor1,tutor1,,\tc\lib\cm
                                                                              */
/* --------------------------- Required Headers ----------------------------- */
#include "tutor2.h" /* Includes stdio.h and tutor3.h */

/* --------------------------------- sum16 ---------------------------------- */
void sum16(char a[],char b[],char result[],char *sign,char *oflo)
/* Sum two 16-bit operands,using 1-bit adder.                                 */
/*   a,b,result: Operand and result arrays                                    */
/*   sign,oflo:  Pointers to sign and overflow flags                          */

{ /* Begin sum16 */
short bit; /* Bit index */
char  ci;  /* Carry-in from previous bit position */
char  co;  /* Carry-out from this bit position */
char  cis; /* Carry-in to sign position from the final digit */

ci='0'; /* Initialize carry-in */
for(bit=15;bit>0;bit--){ /* Sum all the digit bits */
  SUM(result[bit],a[bit],b[bit],ci,&co)
  ci=co;
  } /* END Sum all the digit bits */
cis=co; /* Save carry into sign position */
SUM(result[0],a[0],b[0],ci,&co)
*oflo=XOR(cis,co); /* Oflo = 1 iff carry into sign not= carry-out */
*sign=result[0]; 
} /* END sum16 */

/* --------------------------------- and16 ---------------------------------- */
void and16(char a[],char b[],char result[])
/* AND two 16-bit operands                                                    */
/*   a,b,result: Operand and result arrays                                    */

{ /* BEGIN and16 */
short bit; /* Bit index */

for(bit=15;bit>=0;bit--){ /* Check operand and compute result */
  CKOPERAND(a[bit],b[bit])
  result[bit]=AND(a[bit],b[bit]);
  } /* END Check operand and compute result */
} /* END and16 */

/* --------------------------------- pass16 --------------------------------- */
void pass16(char a[],char result[])
/* Pass 16-bit operand through unaltered                                      */
/*   a,result: Operand and result arrays                                      */

{ /* BEGIN pass16 */
short bit; /* Bit index */

for(bit=15;bit>=0;bit--){ /* Check operand and compute result */
  CKOPERAND(a[bit],'\0')
  result[bit]=a[bit];
  } /* END Check operand and compute result */
} /* END pass16 */

/* --------------------------------- not16 ---------------------------------- */
void not16(char a[],char result[])
/* NOT a 16-bit operand                                                       */
/*   a:      Operand array                                                    */
/*   result: Result array                                                     */

{ /* BEGIN not16 */
short bit; /* bit index */

for(bit=15;bit>=0;bit--){ /* Check operand and compute result */
  CKOPERAND(a[bit],'\0')
  result[bit]=INV(a[bit]);
  } /* END Check operand and compute result */
} /* END not16 */
/*============================================================================*/

00043F29
