/* ================================ tutor2.h ================================ */
/* Declarations and Definitions for tutor2.c                                      */
/* ========================================================================== */

/* ------------------------- Duplication Prevention ------------------------- */

#if !defined(TUTOR2h) /* If tutor2.h has not already been processed,          */
#define TUTOR2H       /* define "already processed" flag, then go ahead   */

/* --------------------------- Required Headers ----------------------------- */
#include <stdio.h>
#include "tutor3.h"

/* ---------------------------- Global Macros ------------------------------- */

                               /*--CKOPERAND--*/
/* Check a and b operands for validity, but ignore b if it's '\0'             */
/*   char a:   Operand                                                              */
/*   char b:   Operand or '\0' to indicate none                               */
#define CKOPERAND(a,b){\
          /* Boolean: True= b operand is invalid: */\
          char binval=(b=='\0')?0:(b!='0'&&b!='1');\
          if((a!='0'&&a!='1')||binval)\
            XCEPTN(printf("Aborted: Only 0 and 1 are valid in an operand.");\
                   exit(1));\
            /* An invalid element was detected in an operand array */\
            /* which was loaded with data from the keyboard. */\
          }
                                  /*--SUM--*/
/* Simulate a 1-bit full adder.                                               */
/*   char res: Result                                                              */
/*   char a:   Operand                                                              */
/*   char b:   Operand                                                              */
/*   char ci:  Carry-in (from previous bit position)                              */
/*   char *co: Pointer to carry-out (for possible carry to next bit)              */
/* ps:         Partial sum of a and b (ignoring ci)                                      */
/* psco: Carry-out from partial sum                                              */
/* cico: Carry-out due to carry-in                                              */
#define SUM(res,a,b,ci,co){\
          char ps;\
          char psco;\
          char cico;\
          CKOPERAND(a,b)\
          ps=XOR(a,b);\
          psco=AND(a,b);\
          cico=AND(ps,ci);\
          *(co)=OR(psco,cico);\
          res=XOR(ps,ci);\
          }
                                  /*--XOR--*/
/* Expression (not an executable macro) to simulate an xor gate. */
#define XOR(a,b) ((a==b)?'0':'1')

                                  /*--OR--*/
/* Expression (not an executable macro) to simulate an or gate. */
#define OR(a,b) ((a=='0'&&b=='0')?'0':'1')

                                  /*--AND--*/
/* Expression (not an executable macro) to simulate an and gate. */
#define AND(a,b) ((a=='1'&&b=='1')?'1':'0')

                                  /*--INV--*/
/* Expression (not an executable macro) to simulate an inverter. */
#define INV(a) ((a=='1')?'0':'1')


/* -------------------------- Function Prototypes --------------------------- */
extern void sum16(char a[],char b[],char result[],char *sign,char *oflo);
extern void and16(char a[],char b[],char result[]);
extern void pass16(char a[],char result[]);
extern void not16(char a[],char result[]);

#endif /* If tutor2.h has not already been processed */
/*============================================================================*/

000475C5
