/* ================================ tutor3.h ================================ */
/* Declarations and Defs for exception handling in tutor1.c and tutor2.c      */
/* ========================================================================== */

/* ------------------------- Duplication Prevention ------------------------- */

#if !defined(TUTOR3h) /* If tutor3.h has not already been processed,          */
#define TUTOR3h       /* define "already processed" flag, then go ahead   */

/* ---------------------------- Global Macros ------------------------------- */

                                 /*--XCEPTN--*/
/* Execute a group of one or more C statements that are supposed to be done   */
/* only when an exception situation occurs during execution.  The argument    */
/* stmt constitutes the group (which needn't be enclosed in braces). Example: */
/*   XCEPTN(   ____________________________________________________           */
/*     printf("EOF looking for matching ')' "                      |          */
/*            "(Is input an error-free C source file?)\a");        |          */
/*     fputs("\n* Aborted: EOF looking for matching ')' "          | stmt     */
/*           "(Is input an error-free C source file?)\a",outchan); |          */
/*     exit(1);____________________________________________________|          */
/*     )                                                                      */
/* The exception-management program  xman  can be configured to recognize     */
/* this macro as an exception-handling routine.                               */
#define XCEPTN(stmt) {stmt;}

#endif /* If tutor3.h has not already been processed */
/*============================================================================*/

0002E39A
